#include <avr/io.h>
#include <string.h>
#include "delay.h"
#include "lcd_display.h"

void lcd_display::lcd_enable_strobe ()
{
  _SFR_IO8 (ctrlport) |= e1bit;
  mdelay (1);
  _SFR_IO8 (ctrlport) &= ~e1bit;
  mdelay (1);
}

lcd_display::lcd_display (char datap, char ctrlp,
			  char rsb, char rwb, char e1b)
{
  dataport = datap;
  ctrlport = ctrlp;
  rsbit = rsb;
  rwbit = rwb;
  e1bit = e1b;
  
  _SFR_IO8 (dataport) = 0x00;
  _SFR_IO8 (ctrlport) &= ~(rsbit | rwbit | e1bit);
  delay (1);
  _SFR_IO8 (dataport) = 0x30;
  delay (1);

  lcd_enable_strobe ();
  mdelay (4);
  lcd_enable_strobe ();
  lcd_enable_strobe ();
  
  _SFR_IO8 (dataport) = 0x3e;
  lcd_enable_strobe ();
  
  _SFR_IO8 (dataport) = 0x0f;
  lcd_enable_strobe ();
  
  _SFR_IO8 (dataport) = 0x01;
  lcd_enable_strobe ();
  
  _SFR_IO8 (dataport) = 0x06;
  lcd_enable_strobe ();
}

void lcd_display::write_string (const char *msg)
{
  unsigned int cntr = 0;
  
  _SFR_IO8 (ctrlport) |= rsbit;
  
  while (msg[cntr])
    {
      _SFR_IO8 (dataport) = msg[cntr];
      lcd_enable_strobe ();
      cntr++;
    }
  
  _SFR_IO8 (ctrlport) &= ~rsbit;  
}
